diff --git a/base/common/src/com/netscape/cms/servlet/cert/CertReviewResponseFactory.java b/base/common/src/com/netscape/cms/servlet/cert/CertReviewResponseFactory.java
index a7d76a4693d878e119bef14fd2f31247482a653c..6071b1dcb90e2b2c2ecbaa400e412df4fc0c83a7 100644
--- a/base/common/src/com/netscape/cms/servlet/cert/CertReviewResponseFactory.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/CertReviewResponseFactory.java
@@ -113,7 +113,9 @@ public class CertReviewResponseFactory {
                 dataPolicy.setDef(dataDef);
 
                 //populate constraints
-                PolicyConstraint dataCons = PolicyConstraintFactory.create(locale, policy.getConstraint());
+                // TODO - fix this.
+                PolicyConstraint dataCons = PolicyConstraintFactory.create(locale, policy.getConstraint(),
+                        policy.getConstraint().getClass().getSimpleName());
                 dataPolicy.setConstraint(dataCons);
 
                 dataPolicySet.addPolicy(dataPolicy);
diff --git a/base/common/src/com/netscape/cms/servlet/cert/EnrollmentProcessor.java b/base/common/src/com/netscape/cms/servlet/cert/EnrollmentProcessor.java
index 9e4686698dd5df992cf2d5efa45bee2ece0093fb..31b235d2aae81543c91cf2a27b729868b87cb3da 100644
--- a/base/common/src/com/netscape/cms/servlet/cert/EnrollmentProcessor.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/EnrollmentProcessor.java
@@ -20,7 +20,6 @@ package com.netscape.cms.servlet.cert;
 import java.util.Enumeration;
 import java.util.HashMap;
 import java.util.Locale;
-import java.util.Map;
 
 import javax.servlet.http.HttpServletRequest;
 
@@ -35,6 +34,7 @@ import com.netscape.certsrv.profile.IProfile;
 import com.netscape.certsrv.profile.IProfileAuthenticator;
 import com.netscape.certsrv.profile.IProfileContext;
 import com.netscape.certsrv.profile.IProfileInput;
+import com.netscape.certsrv.profile.ProfileAttribute;
 import com.netscape.certsrv.profile.ProfileInput;
 import com.netscape.certsrv.request.IRequest;
 import com.netscape.cms.servlet.common.CMSRequest;
@@ -51,9 +51,8 @@ public class EnrollmentProcessor extends CertProcessor {
         // put profile inputs into a local map
         HashMap<String, String> dataInputs = new HashMap<String, String>();
         for (ProfileInput input : data.getInputs()) {
-            Map<String, String> attrs = input.getAttributes();
-            for (Map.Entry<String, String> entry : attrs.entrySet()) {
-                dataInputs.put(entry.getKey(), entry.getValue());
+            for (ProfileAttribute attr: input.getAttrs()) {
+                dataInputs.put(attr.getName(), attr.getValue());
             }
         }
 
diff --git a/base/common/src/com/netscape/cms/servlet/profile/PolicyConstraintFactory.java b/base/common/src/com/netscape/cms/servlet/profile/PolicyConstraintFactory.java
index 6c1d92a721362c9c3942b8cf0263654315928dbe..648e8bc57f51e62061e6f0bcc239c6370c42f2d9 100644
--- a/base/common/src/com/netscape/cms/servlet/profile/PolicyConstraintFactory.java
+++ b/base/common/src/com/netscape/cms/servlet/profile/PolicyConstraintFactory.java
@@ -27,18 +27,21 @@ import com.netscape.certsrv.property.Descriptor;
 
 public class PolicyConstraintFactory {
 
-    public static PolicyConstraint create(Locale locale, IPolicyConstraint cons) {
+    public static PolicyConstraint create(Locale locale, IPolicyConstraint cons, String classId) {
         PolicyConstraint ret = new PolicyConstraint();
         ret.setName(cons.getName(locale));
         ret.setText(cons.getText(locale));
+        ret.setClassId(classId);
 
         Enumeration<String> conNames = cons.getConfigNames();
         while (conNames.hasMoreElements()) {
             String conName = conNames.nextElement();
             PolicyConstraintValue dataVal =
-                    new PolicyConstraintValue(conName, (Descriptor) cons.getConfigDescriptor(locale, conName));
+                    new PolicyConstraintValue(conName, (Descriptor) cons.getConfigDescriptor(locale, conName),
+                            cons.getConfig(conName));
             ret.addConstraint(dataVal);
         }
+
         return ret;
     }
 }
diff --git a/base/common/src/com/netscape/cms/servlet/profile/PolicyDefaultFactory.java b/base/common/src/com/netscape/cms/servlet/profile/PolicyDefaultFactory.java
index fe6b436ab12c57e8f087985c33d181689879ee0c..0d6ab04951c92b75886f8772d2b6e7b0829e216c 100644
--- a/base/common/src/com/netscape/cms/servlet/profile/PolicyDefaultFactory.java
+++ b/base/common/src/com/netscape/cms/servlet/profile/PolicyDefaultFactory.java
@@ -17,13 +17,16 @@
 // --- END COPYRIGHT BLOCK ---
 package com.netscape.cms.servlet.profile;
 
+import java.util.ArrayList;
 import java.util.Enumeration;
+import java.util.List;
 import java.util.Locale;
 
 import com.netscape.certsrv.base.IArgBlock;
 import com.netscape.certsrv.profile.IPolicyDefault;
 import com.netscape.certsrv.profile.PolicyDefault;
 import com.netscape.certsrv.profile.ProfileAttribute;
+import com.netscape.certsrv.profile.ProfileParameter;
 import com.netscape.certsrv.property.Descriptor;
 import com.netscape.certsrv.property.EPropertyException;
 import com.netscape.certsrv.request.IRequest;
@@ -64,4 +67,31 @@ public class PolicyDefaultFactory {
         return ret;
     }
 
+    public static PolicyDefault create(Locale locale, IPolicyDefault def, String classId) throws EPropertyException {
+        PolicyDefault ret = new PolicyDefault();
+        ret.setName(def.getName(locale));
+        ret.setText(def.getText(locale));
+        ret.setClassId(classId);
+
+        Enumeration<String> defNames  = def.getValueNames();
+        while (defNames.hasMoreElements()) {
+            String defName = defNames.nextElement();
+            ProfileAttribute attr = new ProfileAttribute();
+            attr.setName(defName);
+            attr.setDescriptor((Descriptor) def.getValueDescriptor(locale, defName));
+            ret.addAttribute(attr);
+        }
+
+        List<ProfileParameter> pList = new ArrayList<ProfileParameter>();
+        Enumeration<String> paramNames  = def.getConfigNames();
+        while (paramNames.hasMoreElements()) {
+            String paramName = paramNames.nextElement();
+            ProfileParameter p = new ProfileParameter(paramName, def.getConfig(paramName));
+            pList.add(p);
+        }
+        ret.setParams(pList);
+
+        return ret;
+    }
+
 }
diff --git a/base/common/src/com/netscape/cms/servlet/profile/ProfileInputFactory.java b/base/common/src/com/netscape/cms/servlet/profile/ProfileInputFactory.java
index f5a9e7556b531390f1de91242112878d5d52151d..f89d8224e198df38ae896fed413c9482d9353c75 100644
--- a/base/common/src/com/netscape/cms/servlet/profile/ProfileInputFactory.java
+++ b/base/common/src/com/netscape/cms/servlet/profile/ProfileInputFactory.java
@@ -6,6 +6,7 @@ import java.util.Locale;
 import com.netscape.certsrv.base.IArgBlock;
 import com.netscape.certsrv.profile.EProfileException;
 import com.netscape.certsrv.profile.IProfileInput;
+import com.netscape.certsrv.profile.ProfileAttribute;
 import com.netscape.certsrv.profile.ProfileInput;
 import com.netscape.certsrv.request.IRequest;
 
@@ -13,13 +14,14 @@ public class ProfileInputFactory {
 
     public static ProfileInput create(IProfileInput input, IRequest request, Locale locale) throws EProfileException  {
         ProfileInput ret = new ProfileInput();
-        ret.setInputId(input.getName(locale));
+        ret.setName(input.getName(locale));
+        ret.setClassId(input.getClass().getSimpleName());
         Enumeration<String> names = input.getValueNames();
         while (names.hasMoreElements()) {
             String name = names.nextElement();
             String value = input.getValue(name, locale, request);
             if (value != null) {
-                ret.setInputAttr(name, value);
+                ret.addAttribute(new ProfileAttribute(name, value, null));
             }
         }
         return ret;
@@ -27,13 +29,14 @@ public class ProfileInputFactory {
 
     public static ProfileInput create(IProfileInput input, IArgBlock params, Locale locale) throws EProfileException {
         ProfileInput ret = new ProfileInput();
-        ret.setInputId(input.getName(locale));
+        ret.setName(input.getName(locale));
+        ret.setClassId(input.getClass().getSimpleName());
         Enumeration<String> names = input.getValueNames();
         while (names.hasMoreElements()) {
             String name = names.nextElement();
             String value = params.getValueAsString(name, null);
             if (value != null) {
-                ret.setInputAttr(name, value);
+                ret.addAttribute(new ProfileAttribute(name, value, null));
             }
         }
         return ret;
diff --git a/base/common/src/com/netscape/cms/servlet/profile/ProfileProcessServlet.java b/base/common/src/com/netscape/cms/servlet/profile/ProfileProcessServlet.java
index 4b5ef292dad8d7b8c84b774839d0b017e84e4f4f..82b168e6fd6e9cf440120b2c18196f5a7d64f5bb 100644
--- a/base/common/src/com/netscape/cms/servlet/profile/ProfileProcessServlet.java
+++ b/base/common/src/com/netscape/cms/servlet/profile/ProfileProcessServlet.java
@@ -37,8 +37,8 @@ import com.netscape.certsrv.profile.EProfileException;
 import com.netscape.certsrv.profile.ERejectException;
 import com.netscape.certsrv.profile.ProfileAttribute;
 import com.netscape.certsrv.profile.ProfileOutput;
-import com.netscape.certsrv.property.Descriptor;
 import com.netscape.certsrv.property.EPropertyException;
+import com.netscape.certsrv.property.IDescriptor;
 import com.netscape.certsrv.request.IRequest;
 import com.netscape.certsrv.template.ArgList;
 import com.netscape.certsrv.template.ArgSet;
@@ -157,7 +157,7 @@ public class ProfileProcessServlet extends ProfileServlet {
             for (ProfileOutput output: data.getOutputs()) {
                 for (ProfileAttribute attr: output.getAttrs()){
                     ArgSet outputset = new ArgSet();
-                    Descriptor desc = attr.getDescriptor();
+                    IDescriptor desc = attr.getDescriptor();
                     outputset.set(ARG_OUTPUT_ID, attr.getName());
                     outputset.set(ARG_OUTPUT_SYNTAX, desc.getSyntax());
                     outputset.set(ARG_OUTPUT_CONSTRAINT, desc.getConstraint());
